#include <gtk/gtk.h>

static void
window_destroy (GtkWidget* widget, gpointer data)
{
    gtk_main_quit();
}

static void
button_clicked (GtkButton* button, gpointer data)
{
    gtk_main_quit();
}

int main(int argc, char *argv[])
{
    GtkWidget *window, *vbox, *label, *button;

    gtk_init(&argc, &argv);

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

    gtk_container_set_border_width (GTK_CONTAINER(window), 20);
    
    gtk_window_set_title(GTK_WINDOW (window), "GTK Hello");

    g_signal_connect (G_OBJECT (window), "destroy",
                      G_CALLBACK (window_destroy), NULL);

    vbox = gtk_vbox_new(FALSE, 10);
    label = gtk_label_new ("GTK Hello");
    button = gtk_button_new_with_label("Close");

    g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK (button_clicked), NULL);
    
    gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);

    gtk_container_add (GTK_CONTAINER (window), vbox);

    gtk_widget_show_all (window);

    gtk_main();

    return 0;
}
