#!/bin/bash

set -e

if [ -L "$0" ]; then
	realpath=`readlink "$0"`
	SBOX_DIR=`dirname $realpath`
else
	SBOX_DIR=`dirname $0`
fi

SBOX_DIR=`readlink -f $SBOX_DIR`
LD_HACK="$SBOX_DIR/host_shared/lib/ld.so --library-path $SBOX_DIR/host_shared/lib"

. $SBOX_DIR/sbin/compatibility.sh
. $SBOX_DIR/etc/question_func.sh

if [ -f $SBOX_DIR/.run_me_first_done ] ; then
	echo
	echo "This script has already been run ($SBOX_DIR/.run_me_first_done exists)"
	echo
	cont=`question "Would you like to continue anyway?" 1 no`
	if [ "$cont" = "no" ] ; then
		exit 1
	fi
fi

# Mode
mode=`question "Do you want to use sudo mode?" 1 no`
if [ "$mode" = no ] ; then
	if [ `id -u` != 0 ] ; then
		echo "ERROR: This has to be run as root."
		exit 1
	fi
else
	if  [ `id -u` = 0 ] ; then
		echo "ERROR: You don't want to do this as root if using sudo mode!"
		exit 1
	fi
fi

while true; do
	# Group name
	SB_GROUP=`question "Give the name of the scratchbox group" 2 sbox`

	# Create group?
	if [ x"`getent group $SB_GROUP`" = x ] ; then
		echo "The group '$SB_GROUP' does not seem to exist!"
		creategr=`question "Would you like me to create the group '$SB_GROUP' for you?" 1 yes`
		if [ "$creategr" = no ] ; then
			continue
		fi
	fi

	break
done

if ! $SBOX_DIR/sbin/sbox_configure $mode $SB_GROUP ; then
	exit 1
fi

$SBOX_DIR/sbin/sbox_ctl restart

echo
echo "Now you should add one or more users with $SBOX_DIR/sbin/sbox_adduser"
echo
